
function [decoded_data]= MyOfdmReceiver(data,M,N,L,N_OTFS_SYMS,X_nm_tr,tx_data_all)
 %% run transmitter code to load sts and lts and other parameters 
% OTFS_TX;
N_OFDM_SYMS             = 64;         % Number of OFDM symbols or 500*48 otfs grid
MOD_ORDER               =  1;          % Modulation order in power of 2 (1/2/4/6 = BSPK/QPSK/16-QAM/64-QAM)
TX_SCALE                = 1.0;         % Scale for Tx waveform ([0:1])

% OFDM params
SC_IND_PILOTS           = [8 22 44 58];                           % Pilot subcarrier indices
SC_IND_DATA             = [2:7 9:21 23:27 39:43 45:57 59:64];     % Data subcarrier indices
N_SC                    = 64;                                     % Number of subcarriers
CP_LEN                  = 16;                                     % Cyclic prefix length
N_DATA_SYMS             = N_OFDM_SYMS * length(SC_IND_DATA);      % Number of data symbols (one per data-bearing subcarrier per OFDM symbol)
trel = poly2trellis(7, [171 133]);              % Define trellis
channel_coding = .5; % coding rate
trellis_end_length = 8; % bits for trellis to end
sts_f = zeros(1,64);
sts_f(1:27) = [0 0 0 0 -1-1i 0 0 0 -1-1i 0 0 0 1+1i 0 0 0 1+1i 0 0 0 1+1i 0 0 0 1+1i 0 0];
sts_f(39:64) = [0 0 1+1i 0 0 0 -1-1i 0 0 0 1+1i 0 0 0 -1-1i 0 0 0 -1-1i 0 0 0 1+1i 0 0 0];
sts_t = ifft(sqrt(13/6).*sts_f, 64);
sts_t = sts_t(1:16);
lts_f = [0 1 -1 -1 1 1 -1 1 -1 1 -1 -1 -1 -1 -1 1 1 -1 -1 1 -1 1 -1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 1 1 -1 -1 1 1 -1 1 -1 1 1 1 1 1 1 -1 -1 1 1 -1 1 -1 1 1 1 1];
lts_t = ifft(lts_f, 64);
%% Rx processing params

rx_data = data;          % run OFDM tx code to get raw_rx_dec
LTS_CORR_THRESH = 0.9;         % Normalized threshold for LTS correlation
%% Packet detection: auto corr
length_samples= length(rx_data) - 200;
a_sample=16;
while( a_sample < length_samples)
    
    output_a(a_sample)= rx_data(a_sample-length(sts_t) + (1:length(sts_t))) * rx_data(a_sample + (1:length(sts_t)))' ./norm(rx_data(a_sample+(1:length(sts_t)))); 
    
    a_sample= a_sample+1;
       
end
output_a= output_a./max(abs(output_a));
% a=1;
% while(abs(output_a(a))<LTS_CORR_THRESH*max(abs(output_a)) ||isnan(output_a(a)))
%     a=a+1;
% end
index=find(abs(output_a)>.9);
start_index_a=index(1)-15+30*16+32+64+64;

%% lts cross correlation
lts_sample=64;
length_samples=length(rx_data) - 20000;
while( lts_sample < length_samples)
    
    output_lts(lts_sample)= rx_data(lts_sample-length(lts_t) + (1:length(lts_t))) * lts_t' ./norm(rx_data(lts_sample-length(lts_t) + (1:length(lts_t)))); 
    
    lts_sample= lts_sample+1; 
end
output_lts= output_lts./max(abs(output_lts));
%a=1;
% while(abs(output_lts(a))<LTS_CORR_THRESH*max(abs(output_lts)) ||isnan(output_lts(a)))
%     a=a+1;
% end
a=find(abs(output_lts)>=LTS_CORR_THRESH);
start_index_lts=a(1)-63+64+64;  
start_index=start_index_lts;
lts_start=a(1)-64;

disp("start index_lts is");
disp(start_index_lts);
% disp("start index_c is ");
% disp(start_index_c);
disp("start index_a is ");
disp(start_index_a);
figure(1);
subplot(211);
plot((abs(output_a))); 
xlabel('Samples')
title("stf auto");
% % hold on 
% % plot(abs(rx_data)); 
% % hold off
% figure(2);
% title("stf cross");
% plot((abs(output_a)));
subplot(212);
plot((abs(output_lts)));
title("ltf cross correlation");
xlabel('Samples')

%% CFO
LTS_packet_1=rx_data(lts_start:lts_start+63);
LTS_packet_2=rx_data(lts_start+64:lts_start+64+63);
avg_diff=mean(angle(LTS_packet_2./LTS_packet_1));  
freq_offset=(avg_diff)/(2*pi*64);
disp("freq_offset");
disp(freq_offset);
ext_packet=rx_data(lts_start-512:end);
cfo_corr_mark = 0;  %1 for cfo correction. 0 for no cfo correction.
cfo_corr_packet=ext_packet.* exp(cfo_corr_mark*-1i*2*pi*freq_offset*[0:length(ext_packet)-1]);


%%
packet=cfo_corr_packet(1+64+64+512:end);
preamble=packet(1:M*(N+L));
preamble_mat_cp=(vec2mat(preamble,(N+L))).';
preamble_mat=preamble_mat_cp(17:end,:);
H_nm_tr=fft(preamble_mat)./X_nm_tr;
figure;
image(abs(sfft(H_nm_tr)));
rx_decoded=[];
payload=packet(M*(N+L)+1:N_OTFS_SYMS*M*(N+L));
for i=1:N_OTFS_SYMS-1
payload_i=payload((i-1)*M*(N+L)+1:i*M*(N+L));
payload_mat_cp=(vec2mat(payload_i,80)).';
payload_mat=payload_mat_cp(17:end,:);
payload_mat_f=fft(payload_mat,64);
payload_eq=payload_mat_f./H_nm_tr;
payload_tf=payload_eq(SC_IND_DATA, :);
payload_dd=sfft(payload_tf);
rx_decoded=[rx_decoded payload_dd(:).'];
end
% Output: Symbol equalized matrix with pilot phase correction applied
% Remove pilots and flatten the matrix to a vector rx_syms 

%% Demodulation

figure;
scatter(real(rx_decoded), imag(rx_decoded),'filled');
title(' Signal Space of received bits');
xlabel('I'); ylabel('Q');

%% FEC decoder

Demap_out = demapper(rx_decoded,MOD_ORDER,1);

% viterbi decoder
decoded_data = vitdec(Demap_out,trel,7,'trunc','hard');
% 
% %decoded_data is the final output corresponding to tx_data, which can be used
% %to calculate BER
